# coding: utf-8

"""
    Cakemail API

    The Cakemail API exposes multiple APIs including Authentication, Marketing, Contact, Transactional, Analytic, Content, Account and Partner.  # noqa: E501

    The version of the OpenAPI document: 1.12.14
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from cakemail_openapi.configuration import Configuration


class TaskFullResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'status': 'TaskStatus',
        'created_on': 'int',
        'expires_on': 'int',
        'progress': 'int',
        'requested_by': 'RequestedByUser',
        'type': 'TaskType',
        'description': 'str',
        'payload': 'object'
    }

    attribute_map = {
        'id': 'id',
        'status': 'status',
        'created_on': 'created_on',
        'expires_on': 'expires_on',
        'progress': 'progress',
        'requested_by': 'requested_by',
        'type': 'type',
        'description': 'description',
        'payload': 'payload'
    }

    def __init__(self, id=None, status=None, created_on=None, expires_on=None, progress=0, requested_by=None, type=None, description=None, payload=None, local_vars_configuration=None):  # noqa: E501
        """TaskFullResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._status = None
        self._created_on = None
        self._expires_on = None
        self._progress = None
        self._requested_by = None
        self._type = None
        self._description = None
        self._payload = None
        self.discriminator = None

        self.id = id
        self.status = status
        self.created_on = created_on
        self.expires_on = expires_on
        if progress is not None:
            self.progress = progress
        self.requested_by = requested_by
        self.type = type
        if description is not None:
            self.description = description
        self.payload = payload

    @property
    def id(self):
        """Gets the id of this TaskFullResponse.  # noqa: E501


        :return: The id of this TaskFullResponse.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this TaskFullResponse.


        :param id: The id of this TaskFullResponse.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def status(self):
        """Gets the status of this TaskFullResponse.  # noqa: E501


        :return: The status of this TaskFullResponse.  # noqa: E501
        :rtype: TaskStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this TaskFullResponse.


        :param status: The status of this TaskFullResponse.  # noqa: E501
        :type: TaskStatus
        """
        if self.local_vars_configuration.client_side_validation and status is None:  # noqa: E501
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def created_on(self):
        """Gets the created_on of this TaskFullResponse.  # noqa: E501


        :return: The created_on of this TaskFullResponse.  # noqa: E501
        :rtype: int
        """
        return self._created_on

    @created_on.setter
    def created_on(self, created_on):
        """Sets the created_on of this TaskFullResponse.


        :param created_on: The created_on of this TaskFullResponse.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and created_on is None:  # noqa: E501
            raise ValueError("Invalid value for `created_on`, must not be `None`")  # noqa: E501

        self._created_on = created_on

    @property
    def expires_on(self):
        """Gets the expires_on of this TaskFullResponse.  # noqa: E501


        :return: The expires_on of this TaskFullResponse.  # noqa: E501
        :rtype: int
        """
        return self._expires_on

    @expires_on.setter
    def expires_on(self, expires_on):
        """Sets the expires_on of this TaskFullResponse.


        :param expires_on: The expires_on of this TaskFullResponse.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and expires_on is None:  # noqa: E501
            raise ValueError("Invalid value for `expires_on`, must not be `None`")  # noqa: E501

        self._expires_on = expires_on

    @property
    def progress(self):
        """Gets the progress of this TaskFullResponse.  # noqa: E501


        :return: The progress of this TaskFullResponse.  # noqa: E501
        :rtype: int
        """
        return self._progress

    @progress.setter
    def progress(self, progress):
        """Sets the progress of this TaskFullResponse.


        :param progress: The progress of this TaskFullResponse.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                progress is not None and progress < 0):  # noqa: E501
            raise ValueError("Invalid value for `progress`, must be a value greater than or equal to `0`")  # noqa: E501

        self._progress = progress

    @property
    def requested_by(self):
        """Gets the requested_by of this TaskFullResponse.  # noqa: E501


        :return: The requested_by of this TaskFullResponse.  # noqa: E501
        :rtype: RequestedByUser
        """
        return self._requested_by

    @requested_by.setter
    def requested_by(self, requested_by):
        """Sets the requested_by of this TaskFullResponse.


        :param requested_by: The requested_by of this TaskFullResponse.  # noqa: E501
        :type: RequestedByUser
        """
        if self.local_vars_configuration.client_side_validation and requested_by is None:  # noqa: E501
            raise ValueError("Invalid value for `requested_by`, must not be `None`")  # noqa: E501

        self._requested_by = requested_by

    @property
    def type(self):
        """Gets the type of this TaskFullResponse.  # noqa: E501


        :return: The type of this TaskFullResponse.  # noqa: E501
        :rtype: TaskType
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this TaskFullResponse.


        :param type: The type of this TaskFullResponse.  # noqa: E501
        :type: TaskType
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def description(self):
        """Gets the description of this TaskFullResponse.  # noqa: E501


        :return: The description of this TaskFullResponse.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this TaskFullResponse.


        :param description: The description of this TaskFullResponse.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def payload(self):
        """Gets the payload of this TaskFullResponse.  # noqa: E501


        :return: The payload of this TaskFullResponse.  # noqa: E501
        :rtype: object
        """
        return self._payload

    @payload.setter
    def payload(self, payload):
        """Sets the payload of this TaskFullResponse.


        :param payload: The payload of this TaskFullResponse.  # noqa: E501
        :type: object
        """
        if self.local_vars_configuration.client_side_validation and payload is None:  # noqa: E501
            raise ValueError("Invalid value for `payload`, must not be `None`")  # noqa: E501

        self._payload = payload

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TaskFullResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TaskFullResponse):
            return True

        return self.to_dict() != other.to_dict()
